<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px" @submit.native.prevent>
      <el-form-item label="停车场名称" prop="parkingName">
        <el-input
          v-model="queryParams.parkingName"
          placeholder="请输入停车场名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['info:parkingLot:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['info:parkingLot:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['info:parkingLot:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['info:parkingLot:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="parkingLotList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="停车场id" align="center" prop="parkingId" />
      <el-table-column label="停车场名称" align="center" prop="parkingName" />
      <el-table-column label="坐标" align="center" prop="lngLat" />
      <el-table-column label="空余车位" align="center" prop="freeSpots" />
      <el-table-column label="空余充电桩" align="center" prop="freeChargers" />
      <el-table-column label="当前值班人员" align="center" prop="personnelName" />
<!--      <el-table-column label="备注" align="center" prop="memo" />-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="140">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['info:parkingLot:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['info:parkingLot:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改停车场信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="停车场名称" prop="parkingName">
          <el-input v-model="form.parkingName" placeholder="请输入停车场名称" />
        </el-form-item>
        <el-form-item label="坐标" prop="lngLat">
          <el-input v-model="form.lngLat" @focus="openditu">
            {{ form.lngLat}}
          </el-input>
        </el-form-item>
        <el-form-item label="空余车位" prop="freeSpots">
          <el-input-number v-model="form.freeSpots" controls-position="right"   :min="0" placeholder="请输入空余车位" />
        </el-form-item>

        <el-form-item label="空余充电桩" prop="freeChargers">
          <el-input-number v-model="form.freeChargers" controls-position="right"   :min="0" placeholder="请输入空余充电桩" />
        </el-form-item>

        <el-form-item label="备注" prop="memo">
          <el-input v-model="form.memo" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>



    <el-dialog title="地图" :visible.sync="dialogVisible" width="80%">
      <div id='mainMap'>
        <div id="mapDiv" style="width:100%; height:700px">
        </div>
      </div>
      <input type="button" value="清除" @click='clearmian()' />
      <input type="button" value="标点工具" @click='openMarkTool()' />
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click='tijiao'>确定</el-button>
      </span>
    </el-dialog>


  </div>
</template>

<script>
import { listParkingLot, getParkingLot, delParkingLot, addParkingLot, updateParkingLot, exportParkingLot } from "@/api/info/parkingLot";

export default {
  name: "ParkingLot",
  data() {
    return {

      dialogVisible: false,
      map: null,
      handler: null,
      markPoints: '', // 保存标记点的坐标
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 停车场信息表格数据
      parkingLotList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        parkingName: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        parkingName: [
          { required: true, message: "停车场名称不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {



    // 销毁天地图
    destructionTMap ()  {
      if (this.map) {
        this.map = null;
        // 直接将节点给删掉
        console.log('1qsad');

        const parentEl = document.getElementById('mainMap');
        const cahildrenEl1 = document.getElementById('mapDiv');
        if(cahildrenEl1) parentEl.removeChild(cahildrenEl1);
        // 然后再手动将节点加进来
        const newCahildrenEl = document.createElement("div");
        newCahildrenEl.id = 'mapDiv'
        newCahildrenEl.style = 'height: 700px;width: 100%;'
        parentEl.appendChild(newCahildrenEl)
      }
    },

    tijiao() {
      console.log('多边形数据:', this.form.lngLat);
      console.log('多边形数据:', this.markPoints);
      this.form.lngLat = this.markPoints
      this.destructionTMap()
      this.dialogVisible = false;
    },

    clearmian() {
      if (this.handler) this.handler.close();
      this.map.clearOverLays(); // 清除所有覆盖物
      this.markPoints = ''; // 清除保存的标记点坐标
    },

    openMarkTool() {
      console.log("1111111111")
      if (this.handler) this.handler.close(); // 关闭之前的工具

      this.handler = new T.MarkTool(this.map); // 创建标点工具
      this.handler.open(); // 打开标点工具

      this.handler.on("mouseup", (e) => {
        let drawData1 = e.currentLnglat.lat+","+e.currentLnglat.lng;
        this.markPoints = drawData1;
      });

      this.handler.on("close", () => {
        // 标点工具关闭时的处理
        this.handler = null;
      });
    },


    openditu() {
      console.log('打开地图对话框');
      this.dialogVisible = true;
      this.$nextTick(() => {
        const T = window.T;
        const zoom = 12;
        this.map = new T.Map('mapDiv');
        this.map.centerAndZoom(new T.LngLat(103.96, 30.66), zoom);
        // 创建标注工具对象
        this.handler = new T.MarkTool(this.map);
        console.log('handler 初始化完成:', this.handler);
        console.log('kanknak1', this.form.lngLat);
        let points = new T.LngLat();
        if (this.form.lngLat) {
          const coordinates = this.form.lngLat.split(',');
          points =  new T.LngLat(coordinates[1], coordinates[0]);
        }
        // 创建面对象
        console.log('kanknak2', points);
        const marker = new T.Marker(points);
        // 向地图上添加面
        this.map.addOverLay(marker);
      });
    },
    /** 查询停车场信息列表 */
    getList() {
      this.loading = true;
      listParkingLot(this.queryParams).then(response => {
        this.parkingLotList = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        parkingId: null,
        parkingName: null,
        lngLat: null,
        freeSpots: null,
        freeChargers: null,
        memo: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.parkingId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加停车场信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const parkingId = row.parkingId || this.ids
      getParkingLot(parkingId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改停车场信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.parkingId != null) {
            updateParkingLot(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addParkingLot(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const parkingIds = row.parkingId || this.ids;
      this.$modal.confirm('是否确认删除停车场信息编号为"' + parkingIds + '"的数据项？').then(function() {
        return delParkingLot(parkingIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal.confirm('是否确认导出所有停车场信息数据项？').then(() => {
        this.exportLoading = true;
        return exportParkingLot(queryParams);
      }).then(response => {
        this.$download.name(response.msg);
        this.exportLoading = false;
      }).catch(() => {});
    }
  }
};
</script>
